package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.WFStep;

/**
 * 实体[WFIAAction] 数据对象
 */
@TableName(value = "T_SRFWFIAACTION",resultMap = "WFIAActionResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFIAAction extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFStep wfstep;
    private Integer actioncount;
    private String actionlogicname;
    private String actionname;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String fahelper;
    private String memo;
    private String nextcondition;
    private String nextto;
    private Integer orderflag;
    private String pagepath;
    private String panelid;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableId(value= "wfiaactionid",type=IdType.UUID)//指定主键生成策略
    private String wfiaactionid;
    private String wfiaactionname;
    private String wfstepid;
    private String wfstepname;
    /**
     *  设置属性值[ACTIONCOUNT]
     *  @param actioncount
     */
    public void setActioncount(Integer actioncount){
        this.actioncount = actioncount;
        this.set("actioncountdirtyflag",true);
    }
    /**
     *  获取属性值[ACTIONCOUNT]
     */
    public Integer getActioncount(){
        return this.actioncount;
    }
    /**
     *  重置属性值[ACTIONCOUNT]
     */
    public void resetActioncount(){
        this.set("actioncountdirtyflag",false);
        this.actioncount = null;
    }
    /**
     *  设置属性值[ACTIONLOGICNAME]
     *  @param actionlogicname
     */
    public void setActionlogicname(String actionlogicname){
        if(StringUtils.isEmpty(actionlogicname))
            actionlogicname=null;
        this.actionlogicname = actionlogicname;
        this.set("actionlogicnamedirtyflag",true);
    }
    /**
     *  获取属性值[ACTIONLOGICNAME]
     */
    public String getActionlogicname(){
        return this.actionlogicname;
    }
    /**
     *  重置属性值[ACTIONLOGICNAME]
     */
    public void resetActionlogicname(){
        this.set("actionlogicnamedirtyflag",false);
        this.actionlogicname = null;
    }
    /**
     *  设置属性值[ACTIONNAME]
     *  @param actionname
     */
    public void setActionname(String actionname){
        if(StringUtils.isEmpty(actionname))
            actionname=null;
        this.actionname = actionname;
        this.set("actionnamedirtyflag",true);
    }
    /**
     *  获取属性值[ACTIONNAME]
     */
    public String getActionname(){
        return this.actionname;
    }
    /**
     *  重置属性值[ACTIONNAME]
     */
    public void resetActionname(){
        this.set("actionnamedirtyflag",false);
        this.actionname = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[FAHELPER]
     *  @param fahelper
     */
    public void setFahelper(String fahelper){
        if(StringUtils.isEmpty(fahelper))
            fahelper=null;
        this.fahelper = fahelper;
        this.set("fahelperdirtyflag",true);
    }
    /**
     *  获取属性值[FAHELPER]
     */
    public String getFahelper(){
        return this.fahelper;
    }
    /**
     *  重置属性值[FAHELPER]
     */
    public void resetFahelper(){
        this.set("fahelperdirtyflag",false);
        this.fahelper = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[NEXTCONDITION]
     *  @param nextcondition
     */
    public void setNextcondition(String nextcondition){
        if(StringUtils.isEmpty(nextcondition))
            nextcondition=null;
        this.nextcondition = nextcondition;
        this.set("nextconditiondirtyflag",true);
    }
    /**
     *  获取属性值[NEXTCONDITION]
     */
    public String getNextcondition(){
        return this.nextcondition;
    }
    /**
     *  重置属性值[NEXTCONDITION]
     */
    public void resetNextcondition(){
        this.set("nextconditiondirtyflag",false);
        this.nextcondition = null;
    }
    /**
     *  设置属性值[NEXTTO]
     *  @param nextto
     */
    public void setNextto(String nextto){
        if(StringUtils.isEmpty(nextto))
            nextto=null;
        this.nextto = nextto;
        this.set("nexttodirtyflag",true);
    }
    /**
     *  获取属性值[NEXTTO]
     */
    public String getNextto(){
        return this.nextto;
    }
    /**
     *  重置属性值[NEXTTO]
     */
    public void resetNextto(){
        this.set("nexttodirtyflag",false);
        this.nextto = null;
    }
    /**
     *  设置属性值[ORDERFLAG]
     *  @param orderflag
     */
    public void setOrderflag(Integer orderflag){
        this.orderflag = orderflag;
        this.set("orderflagdirtyflag",true);
    }
    /**
     *  获取属性值[ORDERFLAG]
     */
    public Integer getOrderflag(){
        return this.orderflag;
    }
    /**
     *  重置属性值[ORDERFLAG]
     */
    public void resetOrderflag(){
        this.set("orderflagdirtyflag",false);
        this.orderflag = null;
    }
    /**
     *  设置属性值[PAGEPATH]
     *  @param pagepath
     */
    public void setPagepath(String pagepath){
        if(StringUtils.isEmpty(pagepath))
            pagepath=null;
        this.pagepath = pagepath;
        this.set("pagepathdirtyflag",true);
    }
    /**
     *  获取属性值[PAGEPATH]
     */
    public String getPagepath(){
        return this.pagepath;
    }
    /**
     *  重置属性值[PAGEPATH]
     */
    public void resetPagepath(){
        this.set("pagepathdirtyflag",false);
        this.pagepath = null;
    }
    /**
     *  设置属性值[PANELID]
     *  @param panelid
     */
    public void setPanelid(String panelid){
        if(StringUtils.isEmpty(panelid))
            panelid=null;
        this.panelid = panelid;
        this.set("paneliddirtyflag",true);
    }
    /**
     *  获取属性值[PANELID]
     */
    public String getPanelid(){
        return this.panelid;
    }
    /**
     *  重置属性值[PANELID]
     */
    public void resetPanelid(){
        this.set("paneliddirtyflag",false);
        this.panelid = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[工作流交互操作标识]
     *  @param wfiaactionid
     */
    public void setWfiaactionid(String wfiaactionid){
        if(StringUtils.isEmpty(wfiaactionid))
            wfiaactionid=null;
        this.wfiaactionid = wfiaactionid;
        this.set("wfiaactioniddirtyflag",true);
    }
    /**
     *  获取属性值[工作流交互操作标识]
     */
    public String getWfiaactionid(){
        return this.wfiaactionid;
    }
    /**
     *  重置属性值[工作流交互操作标识]
     */
    public void resetWfiaactionid(){
        this.set("wfiaactioniddirtyflag",false);
        this.wfiaactionid = null;
    }
    /**
     *  设置属性值[工作流交互操作名称]
     *  @param wfiaactionname
     */
    public void setWfiaactionname(String wfiaactionname){
        if(StringUtils.isEmpty(wfiaactionname))
            wfiaactionname=null;
        this.wfiaactionname = wfiaactionname;
        this.set("wfiaactionnamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流交互操作名称]
     */
    public String getWfiaactionname(){
        return this.wfiaactionname;
    }
    /**
     *  重置属性值[工作流交互操作名称]
     */
    public void resetWfiaactionname(){
        this.set("wfiaactionnamedirtyflag",false);
        this.wfiaactionname = null;
    }
    /**
     *  设置属性值[互动操作_相关步骤]
     *  @param wfstepid
     */
    public void setWfstepid(String wfstepid){
        if(StringUtils.isEmpty(wfstepid))
            wfstepid=null;
        this.wfstepid = wfstepid;
        this.set("wfstepiddirtyflag",true);
    }
    /**
     *  获取属性值[互动操作_相关步骤]
     */
    public String getWfstepid(){
        return this.wfstepid;
    }
    /**
     *  重置属性值[互动操作_相关步骤]
     */
    public void resetWfstepid(){
        this.set("wfstepiddirtyflag",false);
        this.wfstepid = null;
    }
    /**
     *  设置属性值[WFSTEPNAME]
     *  @param wfstepname
     */
    public void setWfstepname(String wfstepname){
        if(StringUtils.isEmpty(wfstepname))
            wfstepname=null;
        this.wfstepname = wfstepname;
        this.set("wfstepnamedirtyflag",true);
    }
    /**
     *  获取属性值[WFSTEPNAME]
     */
    public String getWfstepname(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.wfstepname)&&(!StringUtils.isEmpty(this.getWfstepid())) && this.getWfstep()!=null)
        {
            this.wfstepname = this.getWfstep().getWfplogicname();
            this.set("wfstepnamedirtyflag",true);
        }
        return this.wfstepname;
    }
    /**
     *  重置属性值[WFSTEPNAME]
     */
    public void resetWfstepname(){
        this.set("wfstepnamedirtyflag",false);
        this.wfstepname = null;
    }
     /**
     *  获取主实体关联数据[WFStep]
     */
    public WFStep getWfstep() {
        return wfstep;
    }
    /**
     *  设置主实体关联数据[WFStep]
     */
    public void setWfstep(WFStep wfstep) {
        this.wfstep = wfstep;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetActioncount();
        resetActionlogicname();
        resetActionname();
        resetCreatedate();
        resetCreateman();
        resetFahelper();
        resetMemo();
        resetNextcondition();
        resetNextto();
        resetOrderflag();
        resetPagepath();
        resetPanelid();
        resetUpdatedate();
        resetUpdateman();
        resetWfiaactionid();
        resetWfiaactionname();
        resetWfstepid();
        resetWfstepname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFIAAction copyTo(WFIAAction targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFIAAction.class, WFIAAction.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfiaactionid();
		return targetEntity;
	}
}